#define MPG_MD_JOINT_STEREO 1

static void i_stereo_k_values(double io,int is_pos,int i,double k[2][576])
{
   if(is_pos == 0)
   {
      k[0][i] = 1;
      k[1][i] = 1;
   }
   else if ((is_pos % 2) == 1)
   {
      k[0][i] = pow(io,(double)((is_pos + 1)/2));
      k[1][i] = 1;
   }
   else
   {
      k[0][i] = 1;
      k[1][i] = pow(io,(double)(is_pos/2));
   }
}


void join_stereo(
		double xr[2][SBLIMIT][SSLIMIT],
		double lr[2][SBLIMIT][SSLIMIT],
		scalefac_type *scalefac,
		struct gr_info_type *gr_info,
		header_info_type *header_info
		)


{
   int sfreq;

   int ms_stereo = (header_info->mode == MPG_MD_JOINT_STEREO) &&
                   (header_info->mode_extension & 0x2);
   int i_stereo = (header_info->mode == MPG_MD_JOINT_STEREO) &&
                  (header_info->mode_extension & 0x1);
   int js_bound;  /* frequency line that marks the beggining of the zero part */
   int sfb,next_sfb_boundary;
   int i,j,sb,ss,ch;
   short is_pos[SBLIMIT*SSLIMIT];
   double is_ratio[SBLIMIT*SSLIMIT];
   double io;
   double k[2][SBLIMIT*SSLIMIT];

   int lsf	= (header_info->ID == 0);

    if(  (gr_info->scalefac_compress % 2) == 1)
     {
       io = (double)0.707106781188;
     }
     else
     {
       io = (double)0.840896415256;
     }


   sfreq=header_info->sampling_frequency_index + (header_info->ID * 3);


   /* intialization */
   for ( i=0; i<SBLIMIT*SSLIMIT; i++ )
      is_pos[i] = 7;

   if ((stereo == 2) && i_stereo )
   {  if (gr_info->window_switching_flag && (gr_info->block_type == 2)) // short block and mixed block
      {  if( gr_info->mixed_block_flag )// mixed block
         {  int max_sfb = 0;

            for ( j=0; j<3; j++ )
            {  int sfbcnt;
               sfbcnt = 2;
               for( sfb=12; sfb >=3; sfb-- )
               {  int lines;
                  lines = sfBandIndex[sfreq].s[sfb+1]-sfBandIndex[sfreq].s[sfb];
                  i = 3*sfBandIndex[sfreq].s[sfb] + (j+1) * lines - 1;
                  while ( lines > 0 )
                  {  if ( xr[1][i/SSLIMIT][i%SSLIMIT] != 0.0 )
                     {  sfbcnt = sfb;
                        sfb = -10;
                        lines = -10;
                     }
                     lines--;
                     i--;
                  }
               }
               sfb = sfbcnt + 1;

               if ( sfb > max_sfb )
                  max_sfb = sfb;

               while( sfb<12 )
               {  sb = sfBandIndex[sfreq].s[sfb+1]-sfBandIndex[sfreq].s[sfb];
                  i = 3*sfBandIndex[sfreq].s[sfb] + j * sb;
                  for ( ; sb > 0; sb--)
                  {  is_pos[i] = scalefac->ch[1].s[j][sfb];
                     if ( is_pos[i] != 7 )
                         if( lsf )
                         {
                              i_stereo_k_values(is_pos[i],io,i,k);
                         }
                         else
                         {
                             is_ratio[i] = tan((double)is_pos[i] * (PI / 12));
                         }
                     i++;
                  }
                  sfb++;
               }

               sb = sfBandIndex[sfreq].s[12]-sfBandIndex[sfreq].s[11];
               sfb = 3*sfBandIndex[sfreq].s[11] + j * sb;
               sb = sfBandIndex[sfreq].s[13]-sfBandIndex[sfreq].s[12];

               i = 3*sfBandIndex[sfreq].s[11] + j * sb;
               for ( ; sb > 0; sb-- )
               {  is_pos[i] = is_pos[sfb];
                  is_ratio[i] = is_ratio[sfb];
                  k[0][i] = k[0][sfb];
                  k[1][i] = k[1][sfb];
                  i++;
               }
             }
             if ( max_sfb <= 3 )
             {  i = 2;
                ss = 17;
                sb = -1;
                while ( i >= 0 )
                {  if ( xr[1][i][ss] != 0.0 )
                   {  sb = i*18+ss;
                      i = -1;
                   } else
                   {  ss--;
                      if ( ss < 0 )
                      {  i--;
                         ss = 17;
                      }
                   }
                }
                i = 0;
                while ( sfBandIndex[sfreq].l[i] <= sb )
                   i++;
                sfb = i;
                i = sfBandIndex[sfreq].l[i];
                for ( ; sfb<8; sfb++ )
                {  sb = sfBandIndex[sfreq].l[sfb+1]-sfBandIndex[sfreq].l[sfb];
                   for ( ; sb > 0; sb--)
                   {  is_pos[i] = scalefac->ch[1].l[sfb];
                      if ( is_pos[i] != 7 )
                         if ( lsf )
                         {
                              i_stereo_k_values(is_pos[i],io,i,k);
                         }
                         else
                         {
                             is_ratio[i] = tan((double)is_pos[i] * (PI / 12));
                         }
                      i++;
                   }
                }
            }
         } //end mixed block
         else// short block
         {  for ( j=0; j<3; j++ )
            {  int sfbcnt;
               sfbcnt = -1;
               for( sfb=12; sfb >=0; sfb-- )
               {  int lines;
                  lines = sfBandIndex[sfreq].s[sfb+1]-sfBandIndex[sfreq].s[sfb];
                  i = 3*sfBandIndex[sfreq].s[sfb] + (j+1) * lines - 1;
                  while ( lines > 0 )
                  {  if ( xr[1][i/SSLIMIT][i%SSLIMIT] != 0.0 )
                     {  sfbcnt = sfb;
                        sfb = -10;
                        lines = -10;
                     }
                     lines--;
                     i--;
                  }
               }
               sfb = sfbcnt + 1;
               while( sfb<12 )
               {  sb = sfBandIndex[sfreq].s[sfb+1]-sfBandIndex[sfreq].s[sfb];
                  i = 3*sfBandIndex[sfreq].s[sfb] + j * sb;
                  for ( ; sb > 0; sb--)
                  {  is_pos[i] = scalefac->ch[1].s[j][sfb];
                     if ( is_pos[i] != 7 )
                         if( lsf )
                         {
                              i_stereo_k_values(is_pos[i],io,i,k);
                         }
                         else
                         {
                             is_ratio[i] = tan( (double)is_pos[i] * (PI / 12));
                         }
                     i++;
                  }
                  sfb++;
               }

               sb = sfBandIndex[sfreq].s[12]-sfBandIndex[sfreq].s[11];
               sfb = 3*sfBandIndex[sfreq].s[11] + j * sb;
               sb = sfBandIndex[sfreq].s[13]-sfBandIndex[sfreq].s[12];

               i = 3*sfBandIndex[sfreq].s[11] + j * sb;
               for ( ; sb > 0; sb-- )
               {  is_pos[i] = is_pos[sfb];
                  is_ratio[i] = is_ratio[sfb];
                  k[0][i] = k[0][sfb];
                  k[1][i] = k[1][sfb];
                  i++;
               }
            }
         } // end short block
      } // end short block and mixed block

      else// long block
      {  i = 31;
         ss = 17;
         sb = 0;
         while ( i >= 0 )
         {  if ( xr[1][i][ss] != 0.0 )
            {  sb = i*18+ss;
               i = -1;
            } else
            {  ss--;
               if ( ss < 0 )
               {  i--;
                  ss = 17;
               }
            }
         }
         i = 0;
         while ( sfBandIndex[sfreq].l[i] <= sb )
            i++;
         sfb = i;
         i = sfBandIndex[sfreq].l[i];
         for ( ; sfb<21; sfb++ )
         {  sb = sfBandIndex[sfreq].l[sfb+1] - sfBandIndex[sfreq].l[sfb];
            for ( ; sb > 0; sb--)
            {  is_pos[i] = scalefac->ch[1].l[sfb];
               if ( is_pos[i] != 7 )
                     if( lsf )
                     {
                           i_stereo_k_values(is_pos[i],io,i,k);
                     }
                     else
                     {
                          is_ratio[i] = tan((double)is_pos[i] * (PI / 12));
                     }
               i++;
            }
         }
         sfb = sfBandIndex[sfreq].l[20];
         for ( sb = 576 - sfBandIndex[sfreq].l[21]; sb > 0; sb-- )
         {  is_pos[i] = is_pos[sfb];
            is_ratio[i] = is_ratio[sfb];
            k[0][i] = k[0][sfb];
            k[1][i] = k[1][sfb];
            i++;
         }
      }
   }

   //end  if ((stereo == 2) && i_stereo )




   for(ch=0;ch<2;ch++)
      for(sb=0;sb<SBLIMIT;sb++)
         for(ss=0;ss<SSLIMIT;ss++)
            lr[ch][sb][ss] = 0;




   if (stereo==2) // stereo
      for(sb=0;sb<SBLIMIT;sb++)
         for(ss=0;ss<SSLIMIT;ss++) {
            i = (sb*18)+ss;
            if ( is_pos[i] == 7 ) {
               if ( ms_stereo ) {
                  lr[0][sb][ss] = (xr[0][sb][ss]+xr[1][sb][ss])/(double)1.41421356;
                  lr[1][sb][ss] = (xr[0][sb][ss]-xr[1][sb][ss])/(double)1.41421356;
               }
               else {
                  lr[0][sb][ss] = xr[0][sb][ss];
                  lr[1][sb][ss] = xr[1][sb][ss];
               }
            }
            else if (i_stereo ) {
                if ( lsf )
                {
                  lr[0][sb][ss] = xr[0][sb][ss] * k[0][i];
                  lr[1][sb][ss] = xr[0][sb][ss] * k[1][i];
                }
               else
                {
                  lr[0][sb][ss] = xr[0][sb][ss] * (is_ratio[i]/(1+is_ratio[i]));
                  lr[1][sb][ss] = xr[0][sb][ss] * (1/(1+is_ratio[i]));
                }
            }
            else {
               printf("Error in streo processing\n");
            }
         }
   else  /* mono , bypass xr[0][][] to lr[0][][]*/
      for(sb=0;sb<SBLIMIT;sb++)
         for(ss=0;ss<SSLIMIT;ss++)
            lr[0][sb][ss] = xr[0][sb][ss];

}
