
#define TESTFRAME 800

#include "basic_io.h"
#include "basic.h"
#include "header_reader.h"
#include "get_scalefactor.h"
#include "requantize.h"
#include "huffman_decode.h"
#include "reorder.h"
#include "joint_stereo.h"
#include "antialias.h"
#include "hybrid.h"
#include "subbandsynthesis.h"
#include "math.h"
#include "alt_types.h"
#include "io.h"
#include "system.h"
#include "stdio.h"

#define IOWR_LED_DATA(base, offset, data) \
  IOWR_16DIRECT(base, (offset) * 2, data) 
#define IORD_LED_DATA(base, offset) \
  IORD_16DIRECT(base, (offset) * 2)
#define IOWR_LED_SPEED(base, data) \
  IOWR_16DIRECT(base + 32, 0, data)



unsigned long F32ToHex(float valueF)
{

    unsigned long* valueL = (unsigned long *) &valueF;
    return *valueL;


}

inline int gen_wave32 (float flt)
    {
        unsigned long  hex=0;
        unsigned int exp,outcome;
        unsigned long  fraction;
        unsigned char sign_whole;
        unsigned char sign_exp;
        unsigned long result;
        unsigned long result2;
        hex=F32ToHex(flt);
        fraction=hex&0x007FFFFF;
        exp=127-((hex&0x7F800000)>>23);
        //sign_exp=((exp&0x800)>>11);
        //exp=exp&0x7FF;
        sign_whole=(hex&0x80000000)>>31;
        fraction=fraction|0x00800000;

            result=(fraction<<7)>>(exp-1);

        result&=0x00FF0000;
        result>>=16;
       // outcome=result;
        return result;
    }


void main()
{
    unsigned char *address_of_first_frame;
    unsigned char *index;
    unsigned char valid[2]={1,1};
    unsigned long int sycnword_count=0;
    unsigned char ii=0; //This variable is used to denote the number of frame that are being analyzed.
    int clip=0;
    int vga,vga_temp;

    printf("OK start.\n");//test;
    find_the_first_frame(&address_of_first_frame,&sycnword_count);
    frame_stat=0;//test;
    sycnword_count=sycnword_count-2;
    block_type_0_count=0;//test;
    //printf("address_of_first_frame is %d\n",address_of_first_frame - data_header);//test;
    index=address_of_first_frame;
    si[0].main_data_end=0;si[1].main_data_end=0;


    initialize_huffman();

    for(frameNum=1;frameNum<TESTFRAME+1;frameNum++)
    {

        ii++;
        if(ii>1) ii=0;
        
        header_reader(&index,&sycnword_count,&header_info[ii],&si[ii],&si[bit_add(ii)],&main_data_beg_bs[ii],&valid[ii]);
        /*if((valid[1]==1)&&(valid[0]==1))
        {
        //printf("I have found the %dst frame starting at this address:%d\n",frameNum,index-header_info[ii].frame_length-data_header);
        }
        else
        {
            //printf("bad frame detected.I quit.\n");exit(0);

        }*/

        int ch,gr;
        for(gr=0;gr< grNum;gr++)
        {gr_global=gr;
        for(ch=0;ch< stereo;ch++)
        {
            get_scale_factors(&si[ii],&scalefac,gr,ch,main_data_beg_bs[ii]);
            //printf("start of huffman\n");
            huffman_decode(is, &si[ii], ch, gr,&header_info[ii],&main_data_beg_bs[ii]);

            main_data_beg_bs[ii].byte_idx_ptr+=(si[ii].ch[ch].gr[gr].part2_3_length/8);
            if(main_data_beg_bs[ii].bit_idx>=(si[ii].ch[ch].gr[gr].part2_3_length%8))
            {
                main_data_beg_bs[ii].bit_idx-=(si[ii].ch[ch].gr[gr].part2_3_length%8);
            }
            else
            {
                main_data_beg_bs[ii].byte_idx_ptr++;
                main_data_beg_bs[ii].bit_idx=main_data_beg_bs[ii].bit_idx+8-si[ii].ch[ch].gr[gr].part2_3_length%8;
            }
            //printf("start of requantize\n");
            
            requantize(&header_info[ii],&scalefac,&si[ii],is,ro[ch],gr,ch);
            //printf("end of requantize\n");
            //print_scalefac(frameNum, gr, ch, si[ii]);//test;
            //print_requantize(frameNum,gr,ch,ro[ch]);//test;

        }
        //printf("start of stereo\n");
        join_stereo(ro,lr,&scalefac,&(si[ii].ch[ch].gr[gr]),&header_info[ii]);

        for(ch=0;ch< stereo;ch++)
        {
            ch_global=ch;
            reorder (lr[ch],re,&(si[ii].ch[ch].gr[gr]),&header_info[ii]);
            antialias(re, hybridIn, &(si[ii].ch[ch].gr[gr]), &header_info[ii]);

            for(vga=0;vga<7;vga++){
            vga_temp=(vga<<3)+vga;
            IOWR_LED_DATA(DE2_VGA_RASTER_INST_BASE, vga_temp,350-gen_wave32(hybridIn[vga][1]));
            IOWR_LED_DATA(DE2_VGA_RASTER_INST_BASE, vga_temp+1,350-gen_wave32(hybridIn[vga][3]));
            IOWR_LED_DATA(DE2_VGA_RASTER_INST_BASE, vga_temp+2,350-gen_wave32(hybridIn[vga][5]));
            IOWR_LED_DATA(DE2_VGA_RASTER_INST_BASE, vga_temp+3,350-gen_wave32(hybridIn[vga][7]));
            IOWR_LED_DATA(DE2_VGA_RASTER_INST_BASE, vga_temp+4,350-gen_wave32(hybridIn[vga][9]));
            IOWR_LED_DATA(DE2_VGA_RASTER_INST_BASE, vga_temp+5,350-gen_wave32(hybridIn[vga][11]));
            IOWR_LED_DATA(DE2_VGA_RASTER_INST_BASE, vga_temp+6,350-gen_wave32(hybridIn[vga][13]));
            IOWR_LED_DATA(DE2_VGA_RASTER_INST_BASE, vga_temp+7,350-gen_wave32(hybridIn[vga][15]));
            IOWR_LED_DATA(DE2_VGA_RASTER_INST_BASE, vga_temp+8,350-gen_wave32(hybridIn[vga][17]));
            }
            IOWR_LED_DATA(DE2_VGA_RASTER_INST_BASE, 63,350-gen_wave32(hybridIn[7][7]));    

            unsigned char sb=0;
            unsigned char ss=0;
            for (sb=0; sb<SBLIMIT; sb++)
            {
                hybrid(hybridIn[sb], hybridOut[sb], sb, ch, &(si[ii].ch[ch].gr[gr]),&header_info[ii]);
            }
//printf("done.\n");
            for (ss=0;ss<18;ss++)
                for (sb=0; sb<SBLIMIT; sb++)
                      if ((ss%2) && (sb%2))
                             hybridOut[sb][ss] = -hybridOut[sb][ss];

            //print_hybrid_output(frameNum,gr,ch,hybridOut);//test;
            //printf("synthesis start\n");
            for (ss=0;ss<18;ss++)
            {
                ss_global=ss;
                for (sb=0; sb<SBLIMIT; sb++)
                    polyPhaseIn[sb] = hybridOut[sb][ss];
                SubBandSynthesis (polyPhaseIn, ch,&(pcm_output[frameNum-1][gr_global][ch_global][ss_global][0])); 
            }
            //printf("synthesis done\n");
        }

        //print_pcm_sample(frameNum,gr,pcm_sample);//test;

        //file_output(pcm_sample,fp,&sample_frames);
        }
              printf("%d ",frameNum);  
    }
printf("done\n");  
while(1)
{
     for(frameNum=0;frameNum<TESTFRAME;frameNum++)
        {//printf("\nframe%d\n",frameNum);
      for(gr_global=0;gr_global<2;gr_global++)
        {//printf("\ngr%d\n",gr_global);
        for(ch_global=0;ch_global< stereo;ch_global++)
            {//printf("\nchannel%d\n",ch_global);
            for (ss_global=0;ss_global<18;ss_global++)
                {//printf("\nss%d\n",ss_global);
                 for(pcm_cnt_global=0;pcm_cnt_global<SBLIMIT;)
                   {
                if(!IORD_16DIRECT(0x00681104,0))
                {
                    usleep(13);
//                    short monitor;
//                    monitor=pcm_output[frameNum][gr_global][ch_global][ss_global][pcm_cnt_global];
//                    printf(" %d ",pcm_output[frameNum][gr_global][ch_global][ss_global][pcm_cnt_global]);
                    IOWR_16DIRECT(0x00681104,0,(unsigned short)pcm_output[frameNum][gr_global][ch_global][ss_global][pcm_cnt_global]);
                    pcm_cnt_global+=2;
                }
                    }
            }
          }
        }
    }
    
    }
//----------------------test information print out---------------------------;
/*  printf("Frame_stat is %d\n",frame_stat);printf("bad_block_count is %d\n",bad_block_count);
    printf("big_value_0_count is %d\n",big_value_0_count);
    printf("big_value_1_count is %d\n",big_value_1_count);
    printf("block_type_0_count is %d\n",block_type_0_count);*/
    //printf("index taken by next circulation is %d\n",index);
    //printf("ptr in main_data_bs structure, bit_idx is %d, byte_idx(offset) is %d.\n", main_data_bs.bit_idx, (unsigned long int)(main_data_bs.byte_idx_ptr-data_header));printf("\n");}
    //byte_idx tells you the location of maindata in forms of  offset from the starting point of data_header
    /*printf("ht[33] info :---------------\n");
        {
            printf("table name is %s"   ,ht[33].tablename);
            printf("xlen is:%d   ",ht[33].xlen);
            printf("ylen is:%d   ",ht[33].ylen);
            printf("lintbis is:%d   ",ht[33].linbits);
            printf("treelen is:%d   ",ht[33].treelen);
            printf("the first  2 values are:0x%x 0x%x   ",ht[33].val[0][0],ht[33].val[0][1]);
            printf("the second 2 values are:0x%x 0x%x   ",ht[33].val[1][0],ht[33].val[1][1]);
            printf("the third  2 values are:0x%x 0x%x   \n",ht[33].val[2][0],ht[33].val[2][1]);

        }*/
}

